import org.ietf.ldap.LDAPAttribute;
import org.ietf.ldap.LDAPAttributeSet;
import org.ietf.ldap.LDAPConnection;
import org.ietf.ldap.LDAPEntry;
import org.ietf.ldap.LDAPException;


/**
 * LDAP Ф³ꤵ줿 DN ǥȥϿ롣
 * 뤤ϻ DN Υȥ롣ȥϿ°ͤ
 * ĤƤϡܥ饹Ǹơ
 *
 * @version 19 May 2002
 * @author  Ryo Ichinose
 */
public class LDAPAddDel
{
	/**
	 * LDAP Protocol Version 3
	 */
	public static final int LDAP_V3 = 3; // LDAPv3


	/**
	 * LDAP Ф³ꤵ줿 DN ǥȥϿ롣
	 * ȥϿ°ͤˤĤƤϸơ
	 *
	 * @param host    ۥ̾⤷ IPɥ쥹
	 * @param binddn  bind 桼 DN
	 * @param bindpw  bind 桼Υѥ
	 * @param dn      Ͽȥ DN
	 */
	public void add( String host, String binddn, String bindpw, String dn )
	{
		// Ͽ륨ȥγ°ͤꤹ롣
		LDAPAttributeSet attrset = new LDAPAttributeSet();


		// posixAccount ɬ°
		String objcls[] = { "posixAccount" };
		String cn[]     = { "name1" };
		String uid[]    = { "123456" };
		String uidnum[] = { "501" };
		String gidnum[] = { "502" };
		String home[]   = { "/home/123456" };

		attrset.add( new LDAPAttribute( "objectclass", objcls ) );
		attrset.add( new LDAPAttribute( "cn", cn ) );
		attrset.add( new LDAPAttribute( "uid", uid ) );
		attrset.add( new LDAPAttribute( "uidNumber", uidnum ) );
		attrset.add( new LDAPAttribute( "gidNumber", gidnum ) );
		attrset.add( new LDAPAttribute( "homeDirectory", home ) );


		// DN °ͤϿ륨ȥ LDAPEntry Υ󥹥
		// Ȥƺ
		LDAPEntry entry = new LDAPEntry( dn, attrset );
		LDAPConnection lc = new LDAPConnection();

		try {
			// LDAP Ф³롣ݡȤϥǥե(389)Ȥ
			lc.connect( host, LDAPConnection.DEFAULT_PORT );
			System.out.println( "Connected to " + host );
			System.out.println();


			// ꤵ줿 DN ӥѥɤǥХ(ǧ)롣
			// ¹Ԥʤ硢anonymous ֤뤳Ȥˤʤ롣
			lc.bind( LDAPAddDel.LDAP_V3, binddn, bindpw );


			// ꥨȥϿ¹Ԥ롣
			lc.add( entry );
			System.out.println( "Successfully added" );

			// ³Ǥ롣
			lc.disconnect();
			System.out.println();		
			System.out.println( "Disconnected" );
		}
		catch( LDAPException e ) {
			System.out.println( "LDAPException occured : " + 
					    e.toString() );
		}
	}


	/**
	 * LDAP Ф³ꤵ줿 DN Υȥ롣
	 *
	 * @param host    ۥ̾⤷ IPɥ쥹
	 * @param binddn  bind 桼 DN
	 * @param bindpw  bind 桼Υѥ
	 * @param dn      ȥ DN
	 */
	public void del( String host, String binddn, String bindpw, String dn )
	{
		LDAPConnection lc = new LDAPConnection();

		try {
			// LDAP Ф³롣ݡȤϥǥե(389)Ȥ
			lc.connect( host, LDAPConnection.DEFAULT_PORT );
			System.out.println( "Connected to " + host );
			System.out.println();


			// ꤵ줿 DN ӥѥɤǥХ(ǧ)롣
			// ¹Ԥʤ硢anonymous ֤뤳Ȥˤʤ롣
			lc.bind( LDAPAddDel.LDAP_V3, binddn, bindpw );


			// ꥨȥϿ¹Ԥ롣
			lc.delete( dn );
			System.out.println( "Successfully deleted" );

			// ³Ǥ롣
			lc.disconnect();

			System.out.println();		
			System.out.println( "Disconnected" );
		}
		catch( LDAPException e ) {
			System.out.println( "LDAPException occured : " + 
					    e.toString() );
		}
	}


	/**
	 * ȥݥ
	 *
	 * @param args 
	 *    <ul>
	 *      <li>args[0] --- ۥ̾⤷ IP ɥ쥹
	 *      <li>args[1] --- bind 桼 DN
	 *      <li>args[2] --- bind 桼Υѥ
	 *      <li>args[3] --- Ͽ( add )/( del )
	 *      <li>args[4] --- Ͽ/ȥ DN
	 *    </ul>
	 */
	public static void main( String[] args )
	{
		LDAPAddDel obj = new LDAPAddDel();

		if ( args[3].equals( "add" ) ) {
			obj.add( args[0], args[1], args[2], args[4] );
		} 
		else if ( args[3].equals( "del" ) ) {
			obj.del( args[0], args[1], args[2], args[4] );
		}
	}
}
