import org.ietf.ldap.LDAPAttribute;
import org.ietf.ldap.LDAPConnection;
import org.ietf.ldap.LDAPException;
import org.ietf.ldap.LDAPModification;
import org.ietf.ldap.LDAPModificationSet;


/**
 * LDAP Ф³ꤵ줿ȥ°ͤФԤ
 *
 * @version 19 May 2002
 * @author  Ryo Ichinose
 */
public class LDAPModify
{
	/**
	 * LDAP Protocol Version 3
	 */
	public static final int LDAP_V3 = 3; // LDAPv3


	/**
	 * ꤵ줿 LDAP Ф³ꤵ줿 DN Ǽ̤륨ȥ
	 * °ФѹԤѹˤϡɲ /  /  
	 * 3 νޤޤ롣
	 *
	 * @param host    ۥ̾⤷ IPɥ쥹
	 * @param binddn  bind 桼 DN
	 * @param bindpw  bind 桼Υѥ
	 * @param cmd     ɲ( add )/( mod )/( del )
	 * @param moddn   °륨ȥ DN
	 * @param name    °̾
	 * @param value   ꤹ°
	 */
	public void modify( String host, String binddn, String bindpw,
			    String cmd,  String moddn,  
			    String name, String value )
	{
		LDAPModificationSet ms = new LDAPModificationSet();
		LDAPAttribute attr = new LDAPAttribute( name, value );

		// cmd ˱ LDAPModificationSet ꤹ̤
		// ѹ롣
		if ( cmd.equals( "add" ) ) {
			ms.add( LDAPModification.ADD, attr );
		}
		else if ( cmd.equals( "mod" ) ) {
			ms.add( LDAPModification.REPLACE, attr );
		}
		else if ( cmd.equals( "del" ) ) {
			ms.add( LDAPModification.DELETE, attr );
		}

		LDAPConnection lc = new LDAPConnection();
		
		try {
			// LDAP Ф³롣ݡȤϥǥե(389)Ȥ
			lc.connect( host, LDAPConnection.DEFAULT_PORT );
			System.out.println( "Connected to " + host );
			System.out.println();


			// ꤵ줿 DN ӥѥɤǥХ(ǧ)롣
			// ¹Ԥʤ硢anonymous ֤뤳Ȥˤʤ롣
			lc.bind( LDAPModify.LDAP_V3, binddn, bindpw );


			// ꥨȥ°¹Ԥ롣
			lc.modify( moddn, ms );
			System.out.println( "Successfully modified" );

			// ³Ǥ롣
			lc.disconnect();
			System.out.println();		
			System.out.println( "Disconnected" );
		}
		catch( LDAPException e ) {
			System.out.println( "LDAPException occured : " + 
					    e.toString() );
		}
	}


	/**
	 * ȥݥ
	 *
	 * @param args 
	 *    <ul>
	 *      <li>args[0] --- ۥ̾⤷ IP ɥ쥹
	 *      <li>args[1] --- bind 桼 DN
	 *      <li>args[2] --- bind 桼Υѥ
	 *      <li>args[3] --- ɲ( add )/( mod )/( del )
	 *      <li>args[4] --- °륨ȥ DN
	 *      <li>args[5] --- °̾
	 *      <li>args[6] --- ꤹ°
	 *    </ul>
	 */
	public static void main( String[] args )
	{
		LDAPModify obj = new LDAPModify();
		obj.modify( args[0], args[1], args[2], args[3], 
			    args[4], args[5], args[6] );
	}
}
