import java.util.Enumeration;
import org.ietf.ldap.LDAPAttribute;
import org.ietf.ldap.LDAPAttributeSet;
import org.ietf.ldap.LDAPConnection;
import org.ietf.ldap.LDAPEntry;
import org.ietf.ldap.LDAPException;
import org.ietf.ldap.LDAPSearchResults;


/**
 * ꤵ줿 LDAP Ф³˱ǥ쥯ȥꥨȥ򸡺
 * ꤵ줿°ɽ롣
 *
 * @version 19 May 2002
 * @author  Ryo Ichinose
 */
public class LDAPSearch
{
	/**
	 * LDAP Protocol Version 3
	 */
	public static final int LDAP_V3 = 3; // LDAPv3


	/**
	 * ꤵ줿 LDAP Ф³˱ǥ쥯ȥꥨȥ
	 * 򸡺Υȥ°ɽ롣긡١ʲƤ
	 * ȥ򸡺롣
	 *
	 * @param host    ۥ̾⤷ IPɥ쥹
	 * @param binddn  bind 桼 DN
	 * @param bindpw  bind 桼Υѥ
	 * @param base    ١
	 * @param filter  ե륿
	 */
	public void search( String host, String binddn, String bindpw,
			    String base, String filter )
	{
		// °ꥹ(°)
		String attrs[] = { LDAPConnection.ALL_USER_ATTRS };

		LDAPConnection lc = new LDAPConnection();

		try {
			// LDAP Ф³롣ݡȤϥǥե(389)Ȥ
			lc.connect( host, LDAPConnection.DEFAULT_PORT );
			System.out.println( "Connected to " + host );
			System.out.println();


			// ꤵ줿 DN ӥѥɤǥХ(ǧ)롣
			// ¹Ԥʤ硢anonymous ֤뤳Ȥˤʤ롣
			lc.bind( LDAPSearch.LDAP_V3, binddn, bindpw );


			// ǤΥǥ쥯ȥꥨȥθԤ
			LDAPSearchResults results =	lc.search( 
				base,                     // ١
				LDAPConnection.SCOPE_SUB, // 
				filter,                   // ե륿
				attrs,                    // °ꥹ
				false                     // °̾°ͤμ
			);

			// 줿ȥɽ롣
			while( results.hasMoreElements() ) {
				showLDAPEntry( results.next() );
			}

			// ³Ǥ롣
			lc.disconnect();
			System.out.println();		
			System.out.println( "Disconnected" );
		}
		catch( LDAPException e ) {
			System.out.println( "LDAPException occured : " + 
					    e.toString() );
		}
	}


	private void showLDAPEntry( LDAPEntry entry )
	{
		System.out.println( "Listing attributes of " + entry.getDN() + " :" );
		Enumeration items = entry.getAttributeSet().getAttributes();

		while( items.hasMoreElements() ) {
			// °Фʣ°ͤꤵƤǽ뤬
			// ǤϺǽ°ͤΤɽ뤳Ȥˤ롣
			LDAPAttribute attr = ( LDAPAttribute )items.nextElement();
			Enumeration vals = attr.getStringValues();
			String val  = ( String )vals.nextElement();
			System.out.println( "  " + attr.getName() + ": " + val );
		}

		System.out.println();		
	}


	/**
	 * ȥݥ
	 *
	 * @param args 
	 *    <ul>
	 *      <li>args[0] --- ۥ̾⤷ IP ɥ쥹
	 *      <li>args[1] --- bind 桼 DN
	 *      <li>args[2] --- bind 桼Υѥ
	 *      <li>args[3] --- ١
	 *      <li>args[4] --- ե륿
	 *    </ul>
	 */
	public static void main( String[] args )
	{
		LDAPSearch obj = new LDAPSearch();
		obj.search( args[0], args[1], args[2], args[3], args[4] );
	}
}
